## ash-berry-0.2-8.tar.bz2

=== Makefile ===
PROG=	sh
SRCS=	builtins.c cd.c dirent.c bltin/echo.c error.c eval.c exec.c expand.c \
	input.c jobs.c mail.c main.c memalloc.c miscbltin.c \
	mystring.c nodes.c options.c parser.c redir.c show.c \
	syntax.c trap.c output.c var.c bltin/test.c \
	bltin/mount.c bltin/umount.c bltin/cat.c bltin/lsmod.c bltin/rmmod.c \
	bltin/losetup.c bltin/pivot_root.c bltin/sleep.c

OBJ1 =	init.o
OBJ2 =	builtins.o cd.o dirent.o bltin/echo.o error.o eval.o exec.o expand.o \
	input.o jobs.o mail.o main.o memalloc.o miscbltin.o \
	mystring.o nodes.o options.o parser.o redir.o show.o \
	syntax.o trap.o output.o var.o bltin/test.o \
	bltin/mount.o bltin/umount.o bltin/cat.o bltin/lsmod.o bltin/rmmod.o \
	bltin/losetup.o bltin/pivot_root.o bltin/sleep.o

MOD_OBJ = ./module-init-tools-3.0/insmod.o

OBJS =	$(OBJ1) $(OBJ2)

#CFLAGS = $(RPM_OPT_FLAGS) -DSHELL -I/usr/include/linux -I./modutils-2.4.15/include -I. -D__BIT_TYPES_DEFINED__
CFLAGS = $(RPM_OPT_FLAGS) -DSHELL -I. -D__BIT_TYPES_DEFINED__
LDFLAGS += -s

CLEANFILES =\
	builtins.c builtins.h init.c mkinit mknodes mksyntax \
	nodes.c nodes.h syntax.c syntax.h token.def

all:	$(OBJS) $(MOD_LIB) $(MOD_OBJ)
	$(CC) $(STATIC) -o $(PROG) $(OBJS) $(MOD_OBJ) $(LDFLAGS)

install: all
	install sh /bin/ash
	install -m 644 sh.1 /usr/man/man1/ash.1

parser.o: token.def
token.def: mktokens
	sh ./mktokens

builtins.h builtins.c: mkbuiltins
	sh ./mkbuiltins

init.c: mkinit $(SRCS)
	./mkinit '${CC} -c $(CFLAGS) init.c' $(SRCS)
	touch init.c

mkinit: mkinit.c
	$(CC) $(CFLAGS) $(LDFLAGS) mkinit.c -o $@ $(LDADD)

nodes.c nodes.h: mknodes nodetypes nodes.c.pat
	./mknodes nodetypes nodes.c.pat

mknodes: mknodes.c
	$(CC) $(CFLAGS) $(LDFLAGS) mknodes.c -o $@ $(LDADD)

syntax.c syntax.h: mksyntax
	./mksyntax

mksyntax: mksyntax.c parser.h
	$(CC) $(CFLAGS) $(LDFLAGS) mksyntax.c -o $@ $(LDADD)

clean:
	rm -f core $(CLEANFILES) $(PROG) $(OBJS)

.c.o:
	${CC} ${CFLAGS} -o $@ -c $<

=== debian/control ===
Source: ash-knoppix
Section: base
Priority: optional
Maintainer: Klaus Knopper <knoppix@knopper.net>
Build-Depends: debhelper (>> 3.0.0)
Build-Depends: dietlibc-dev (>> 0.15)
Standards-Version: 3.5.2

Package: ash-knoppix
Architecture: any
Depends: ${shlibs:Depends}
Conflicts: ash
Replaces: ash
Provides: ash
Description: A smaller version of the Bourne shell enhanced with some builtins
 The ash shell is a clone of Berkeley's Bourne shell. Ash supports all
 of the standard sh shell commands, but is considerably smaller than bash.
 The ash shell lacks some features (for example, command-line histories),
 but needs a lot less memory.
 You should install ash if you need a lightweight shell with many of the
 same capabilities as the bash shell.
 This version has a stripped-down but functional mount and umount builtin
 plus insmod/rmmod needed for the KNOPPIX boot Floppy.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=3

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	

	touch configure-stamp

build: configure-stamp build-stamp
build-stamp:
	dh_testdir

	# Add here commands to compile the package.

# Build modutils library
	( cd modutils-2.4.15 ; \
	CC="diet gcc" ./configure --disable-compat-2-0 \
	--disable-combined \
 	--disable-rmmod \
	--disable-lsmod \
	--disable-kerneld \
	--disable-insmod-static && \
	$(MAKE) CC="diet gcc" CFLAGS="-D__DIETLIBC__ -DNDEBUG -Derror=merror -Os" depend && \
	$(MAKE) CC="diet gcc" CFLAGS="-D__DIETLIBC__ -DNDEBUG -Derror=merror -Os" -C util all && \
	$(MAKE) CC="diet gcc" CFLAGS="-D__DIETLIBC__ -DNDEBUG -Derror=merror -Os" -C obj all && \
	$(MAKE) CC="diet gcc" CFLAGS="-D__DIETLIBC__ -DNDEBUG -Derror=merror -Os" -C insmod insmod.o )

# Build static version of ash-knoppix
	# We need a VERY small binary, so let's try to use libc5
	# Packages altgc and lib5-altdev needed
	$(MAKE) mkinit
	CC="diet gcc" $(MAKE) CC="diet gcc" STATIC="-static" LDFLAGS="-s -Wl,-qmagic"
	mv sh ash.static

# Now build a dynamic version of ash-knoppix
	$(MAKE) clean
	$(MAKE) -C modutils-2.4.15 clean
	( cd modutils-2.4.15 ; \
	CC="gcc" ./configure --disable-compat-2-0 \
	--disable-combined \
 	--disable-rmmod \
	--disable-lsmod \
	--disable-kerneld \
	--disable-insmod-static && \
	$(MAKE) CC="gcc" CFLAGS="-DNDEBUG -Derror=merror -Os" depend && \
	$(MAKE) CC="gcc" CFLAGS="-DNDEBUG -Derror=merror -Os" -C util all && \
	$(MAKE) CC="gcc" CFLAGS="-DNDEBUG -Derror=merror -Os" -C obj all && \
	$(MAKE) CC="gcc" CFLAGS="-DNDEBUG -Derror=merror -Os" -C insmod insmod.o )
	$(MAKE) RPM_OPT_FLAGS="-Os" LDFLAGS="-s"
	mv sh ash

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	-rm -f ash ash.static
	-$(MAKE) -C modutils-2.4.15 clean
	-$(MAKE) clean

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/ash-knoppix.
	mkdir -p $(CURDIR)/debian/ash-knoppix/bin \
	         $(CURDIR)/debian/ash-knoppix/usr/share/man/man1

	install -m 755 ash $(CURDIR)/debian/ash-knoppix/bin/ash
	install -m 644 sh.1 $(CURDIR)/debian/ash-knoppix/usr/share/man/man1/ash.1
	ln -sf ash.1 $(CURDIR)/debian/ash-knoppix/usr/share/man/man1/bsh.1
	ln -sf ash   $(CURDIR)/debian/ash-knoppix/bin/bsh
	install -m 755 ash.static $(CURDIR)/debian/ash-knoppix/bin/ash.static

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
#	dh_installdebconf	
	dh_installdocs
	dh_installexamples
	dh_installmenu
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
	dh_installcron
	dh_installman
	dh_installinfo
#	dh_undocumented
	dh_installchangelogs 
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_makeshlibs
	dh_installdeb
#	dh_perl
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
